                                              //+------------------------------------------------------------------+
//|                                              Test Trading Model |
//|                                    Copyright  2013, W. B. Davis |
//|                                                                  |
//+------------------------------------------------------------------+
extern int MagicNumber =54321;
extern double TakeProfit =1000;
extern double Lots = 0.1;
extern double StopLoss =500;
extern double TrailingStop =250;
extern double MinProfit = 250;
extern double PipasPoints= 10;
extern bool CheckOncePerBar = true;
extern bool UseTimer = false;
extern bool UseLocalTime = false;


extern int StartMonth =6;
extern int StartDay = 15;
extern int StartHour= 7;
extern int StartMinute = 0;

extern int EndMonth = 12; 
extern int EndDay = 15;
extern int EndHour =2;
extern int EndMinute = 30;

datetime CurrentTimeStamp;

int cnt,BuyTicket,SellTicket,total;
#include <stdlib.mqh>


//-------------------------------------------

int init()
   {
   if(TakeProfit <1)
      Print("TakeProfit not entered");
   }      

 // {
   
   //---- try to set new value
  // if(GlobalVariableSet("smi",1)==0)
  //  return(false);
    
  //} 
  //---- continue processing
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
  
  if(Bars<100)
     {
     Print("bars less than 100");
     return(0);  
     }
     
  if(AccountFreeMargin()<(1000*Lots))
     {
     Print("We have no money. Free Margin = ", AccountFreeMargin()); 
     return(0);
     }
   
  //Execute on bar open
   if(CheckOncePerBar == true)
	   {
		int BarShift = 1;
		if(CurrentTimeStamp !=Time[0])
			{
		   CurrentTimeStamp = Time[0];
			bool NewBar = true;
			}
		else NewBar = false;
	   }
   else
	   {
		NewBar = true;
		BarShift = 0;
	   }		

   if(UseTimer == true)
   {
   
       //Convert start Time
     string StartConstant = StringConcatenate(Year(),".",StartMonth,".",StartDay,".",StartHour,".",StartMinute);
     
     datetime StartTime = StrToTime(StartConstant);
     if(StartMonth ==12 && StartDay == 31 && EndMonth ==1) int EndYear = Year() +1;
     else EndYear = Year();
     
     //Convert end Time
     string EndConstant = StringConcatenate(EndYear,".",EndMonth,".",EndDay,".",EndHour,".",EndMinute);
     
     datetime EndTime = StrToTime(EndConstant);
     
     //Choose local or server Time
     if(UseLocalTime == true) datetime CurrentTime = TimeLocal();
     else CurrentTime = TimeCurrent();
     
     //Check for trade condition
     if(StartTime <= CurrentTime && EndTime > CurrentTime)
      {
         bool TradeAllowed = true;
      }
      else TradeAllowed = false;
     } 
   else TradeAllowed = true;   
 
 //Check if a trade is currently open
   SellTicket =0;
   BuyTicket =0;
   for(int x=OrdersTotal()-1;x>=0;x--)
    {
    if(OrderSelect(x, SELECT_BY_POS, MODE_TRADES) )
     {
     if(OrderType()==OP_SELL && OrderMagicNumber()==MagicNumber)  SellTicket = OrderTicket() ;
     if(OrderType()==OP_BUY && OrderMagicNumber()==MagicNumber)   BuyTicket = OrderTicket() ;
     }
    else
     {
     Alert("Error checking open orders ",ErrorDescription(GetLastError() ));
     return(0);
     }
    } 
  
// indicators section
if(NewBar)
 {
 double smi = iCustom(Symbol(),0,"Stochastic Momentum Index", 10,8,5,5,0,BarShift);
 double smiprev = iCustom(Symbol(),0,"Stochastic Momentum Index", 10,8,5,5,0,BarShift+1);
 double signal = iCustom(Symbol(),0,"Stochastic Momentum Index",10,8,5,5,1,BarShift);
 double signalprev = iCustom(Symbol(),0,"Stochastic Momentum Index",10,8,5,5,1,BarShift+1);
    
 
     // Begin trade block--check if trading is open for the EA and that other EAs on your server are not active
     if(TradeAllowed == true)
       while (IsTradeContextBusy()) Sleep(10);
        
     // Check for possible long position   
     if (BuyTicket == 0 && smi > signal && smiprev < signalprev)
          {
          BuyTicket=OrderSend(Symbol(),OP_BUY,Lots,Ask,30,0,0,"Awesome Trading",MagicNumber,0,Green);
           if(BuyTicket >0)
             {
             Print("BUY order opened : ",OrderOpenPrice(),"smi ",smi, " smi_signal ",signal); 
             //SendNotification("Buy Order Signal "+Symbol());
             OrderSelect(BuyTicket,SELECT_BY_TICKET);
             double buy_entry_price = OrderOpenPrice();
             if(StopLoss > 0.0)
               if(OrderModify(BuyTicket,buy_entry_price,buy_entry_price - (StopLoss * Point),buy_entry_price + (TakeProfit * Point),0,Yellow) )
                 Print("BuyTakeProfit ",TakeProfit,"  BuyStopLoss  ", StopLoss);
               else
                 Print("Error input of Stop Loss & Take Profit : ",ErrorDescription(GetLastError() ) );
             }
            else 
              Print("Error opening BUY order : ",ErrorDescription(GetLastError() ) );
           
           return(0);
          }
            
     // check for short position (SELL) possibility
     if(SellTicket == 0 && smi < signal  && smiprev > signalprev)
          {
          SellTicket=OrderSend(Symbol(),OP_SELL,Lots,Bid,30,0,0,"Awesome Trading",MagicNumber,0,Red);
          if(SellTicket>0)
             {
             if(OrderSelect(SellTicket,SELECT_BY_TICKET,MODE_TRADES) )
               {
               Print("SELL order opened : ",OrderOpenPrice(),smi, " smi_signal ",signal);
               //SendNotification("Buy Order Signal "+Symbol());
               double sell_entry_price = OrderOpenPrice();
               if(StopLoss > 0 )
                 if(OrderModify(SellTicket, sell_entry_price,sell_entry_price + (StopLoss * Point) ,sell_entry_price - (TakeProfit * Point) , 0) )
                   Print("SellTakeProfit ",TakeProfit,"  SellStopLoss  ", StopLoss);
                 else
                   Print("Error input of Stop Loss & Take Profit : ",ErrorDescription(GetLastError() ) );
               }  
             }
             else 
               Print("Error opening SELL order : ",ErrorDescription(GetLastError() ) );
               
           return(0);
          }
 }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   if(BuyTicket>0 )
     {
     if(OrderSelect(BuyTicket, SELECT_BY_TICKET) )
       {
       if(smi < signal)
          {
          if(OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet) )
            Print("BUY order closed : ",OrderClosePrice());//close position
          else  
            Print("Error closing Buy order @ ",Bid," ",ErrorDescription(GetLastError() ) );
          }
          // check for trailing stop
       if(TrailingStop>0)  
          {                 
          if(Bid-OrderOpenPrice()>(Point*MinProfit))
            {
            double tstop= Bid-(TrailingStop*Point);
            if(OrderStopLoss()< tstop-PipasPoints*Point )
                {
                if(OrderModify(OrderTicket(),OrderOpenPrice(),tstop,OrderTakeProfit(),Green)==false )
                  Print("Error modifying trailing stop @ ",tstop,"Bid= ",Bid," ",ErrorDescription(GetLastError() ) );
                }
            }
          }
       }
     }
     
   if(SellTicket>0 )
     {
     if(OrderSelect(SellTicket, SELECT_BY_TICKET) )
       {
       if(smi > signal)
         {
          if(OrderClose(OrderTicket(),OrderLots(),Ask,30,Violet) )
            Print("SELL order closed : ",OrderClosePrice()); // close position
          else  
            Print("Error closing Sell order @ ",Ask," ",ErrorDescription(GetLastError() ) );
         }                    
                    
          // check for trailing stop
       if(TrailingStop>0)  
         {                 
         if((OrderOpenPrice()-Ask)>(Ask+Point*MinProfit))
            {
            tstop= Ask+(TrailingStop*Point);
            if(OrderStopLoss()> tstop+PipasPoints*Point )
               {
               if(OrderModify(OrderTicket(),OrderOpenPrice(),tstop,OrderTakeProfit(),Red)==false )
                 Print("Error modifying trailing stop @ ",tstop,"Ask= ",Ask," ",ErrorDescription(GetLastError() ) );
               }
            }
         }
       }
     }
    
     
   return(0);
  }
// the end.